=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-08-25 12:46:42 +0000
+++ bzrlib/commands.py	2005-08-25 12:57:59 +0000
@@ -1523,7 +1523,7 @@
             merge_type = ApplyMerge3
 
         if revision is None or len(revision) < 1:
-            base = (None, None)
+            base = (None, "auto")
             other = (branch, -1)
         else:
             if len(revision) == 1:

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-08-25 12:46:42 +0000
+++ bzrlib/merge.py	2005-08-25 12:57:59 +0000
@@ -273,12 +273,15 @@
                                        "base")
             base_is_ancestor = True
         else:
-            if base_revision[1] == -1:
+            if base_revision[1] == "auto":
+                base_revno, base_rev_id = this_branch.common_ancestor(other_branch)
+                base_branch, base_tree = get_tree((base_revision[0], "revid:%s" % base_rev_id), tempdir, "base")
+            elif base_revision[1] == -1:
                 base_branch, base_tree = get_tree(base_revision, tempdir, "base")
                 base_rev_id = base_branch.last_patch()
             elif base_revision[1] is None:
-                base_revno, base_rev_id = this_branch.common_ancestor(other_branch)
-                base_branch, base_tree = get_tree((base_revision[0], "revid:%s" % base_rev_id), tempdir, "base")
+                base_branch, base_tree = get_tree(base_revision, tempdir, "base")
+                base_rev_id = None
             else:
                 base_branch, base_tree = get_tree(base_revision, tempdir, "base")
                 base_rev_id = base_branch.lookup_revision(base_revision[1])

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-08-25 10:04:51 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-08-25 12:57:59 +0000
@@ -496,7 +496,7 @@
         mary_branch.commit("change file2")
         # john should be able to merge with no conflicts.
         merge_type = ApplyMerge3
-        base = ("original", None)
+        base = ("original", "auto")
         other = ("mary", -1)
         merge(other, base, check_clean=True, merge_type=merge_type, this_dir="original")
         self.assertEqual("John\n", open("original/file1", "rt").read())

